<?xml version="1.0" encoding="utf-8"?>
<!--

 Copyright © 2009-2016 Intel Corporation. All rights reserved.

 The information contained herein is the exclusive property of
 Intel Corporation and may not be disclosed, examined, or reproduced in
 whole or in part without explicit written authorization from the Company.

-->
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:msxsl="urn:schemas-microsoft-com:xslt"
                exclude-result-prefixes="msxsl"
                xmlns:exsl="http://exslt.org/common"
                exsl:keep_exsl_namespace=""
                syntax="norules"
                xmlns:boolean="http://www.w3.org/2001/XMLSchema#boolean"
                xmlns:int="http://www.w3.org/2001/XMLSchema#int"
                xmlns:double="http://www.w3.org/2001/XMLSchema#double"
                xmlns:str="http://exslt.org/strings">
  <xsl:output indent="yes" method="xml"/>
  <xsl:param name="type"/>
  <xsl:template match="/">
    <knobs>
      <xsl:if test="$type = 'survey' or
              $type = 'suitability' or
              $type = 'dependencies' or
              $type = 'map'">
        <enumKnob id="mrteMode" displayName="%MrteMode" cliName="mrte-mode">
          <xsl:if test="exsl:ctx('hostOS') != 'Windows'">
            <xsl:attribute name="boolean:visible">false</xsl:attribute>
          </xsl:if>
          <description>%MrteModeDescription</description>
          <values>
            <value displayName="%Auto" cliName="auto">auto</value>
            <value displayName="%Native" cliName="native">native</value>
            <value displayName="%Mixed" cliName="mixed">mixed</value>
            <value displayName="%Managed" cliName="managed">managed</value>
            <defaultValue>auto</defaultValue>
          </values>
          <boolean:knobProperty name="inheritable">true</boolean:knobProperty>
          <knobProperty name="style">radioButton</knobProperty>
        </enumKnob>
      </xsl:if>
      <stringKnob id="process_for_analysis" displayName="knob.process_for_analysis.name" cliName="executable-of-interest">
        <description>knob.process_for_analysis.description</description>
        <value></value>
        <boolean:knobProperty name="inheritable">true</boolean:knobProperty>
      </stringKnob>
      <xsl:if test="$type = 'survey' or
              $type = 'tripcounts'">
        <booleanKnob id="support_multi_isa_binaries" displayName="knob.support_multi_isa_binaries.name" cliName="support-multi-isa-binaries">
          <description>knob.support_multi_isa_binaries.description</description>
          <boolean:defaultValue>false</boolean:defaultValue>
          <boolean:knobProperty name="inheritable">true</boolean:knobProperty>
        </booleanKnob>
      </xsl:if>
      <xsl:if test="$type = 'survey' or
              $type = 'suitability'">
        <intKnob id="interval" displayName="%SamplingInterval" cliName="interval">
          <description>%SamplingIntervalDescription</description>
          <int:min>1</int:min>
          <int:max>1000</int:max>
          <int:defaultValue>10</int:defaultValue>
        </intKnob>
        <intKnob id="dataLimit" displayName="%DataLimit" cliName="data-limit">
          <description>%DataLimitDescription</description>
          <int:min>1</int:min>
          <int:max>1024000</int:max>
          <int:defaultValue>100</int:defaultValue>
        </intKnob>
        <intKnob id="resumeAfter" cliName="resume-after" displayName="%ResumeAfter">
          <description>knob.resumeAfter.description</description>
          <int:min>0</int:min>
          <int:max>10000000</int:max>
          <int:defaultValue>0</int:defaultValue>
        </intKnob>
      </xsl:if>
    </knobs>
  </xsl:template>
</xsl:stylesheet>
