function onDocumentLoad() {
    setTimeout(function () {
        Page.get().log("OnDocumentLoad() called");

        // Initialization of expanders
        expanderInitialization();

        // list of all requests see in model.js
        if (Page.get().isTemplate())
            LoopRequest.send(render);
        else
            RowUpdateCallback.send(function (rowID) {
                setTimeout(function () { LoopRequest.send(render, { rowID: rowID }); }, 0);
            });
    }, 0);
}

// Initialization of expanders
function expanderInitialization() {
    el = document.getElementsByClassName('expander');
    for (var i = 0; i < el.length; i++)
        el[i].onclick = function () {
            this.classList.toggle('closed');

            // There is an assumption that "expansion" element is immediatelly after "expander" element like this:
            //     <div class="essential">...</div>
            //     <div class="expander"></div>
            //     <div class="expansion">...</div>
            // The "essential" section (if present) will be closed when "expansion" is opened. 
            if (!this.nextElementSibling.classList.contains('expansion'))
                return;

            var exp = this.nextElementSibling;
            var ess = this.previousElementSibling.classList.contains('essential') ? this.previousElementSibling : null;

            // opened. has to be closed
            if (exp.offsetHeight != 0) {
                exp.style.height = exp.offsetHeight + 'px';             // restore height value instead of 'auto'
                setTimeout(function () { exp.style.height = 0; }, 50);  // and close by height = 0;
                if (ess) {
                    ess.style.height = ess.calculateHeight() + 'px';
                    setTimeout(function () { ess.style.height = 'auto'; }, 500);
                }
            } else { // closed. has to be opened
                exp.style.height = exp.calculateHeight() + 'px';                // apply exact 'height' to <div>
                if (ess) {
                    ess.style.height = ess.offsetHeight + 'px';
                    setTimeout(function () { ess.style.height = 0; }, 50);
                }
                setTimeout(function () { exp.style.height = 'auto'; }, 500);    // setup 'auto' to do not adjust height on window resize
            }
        }
}

HTMLDivElement.prototype.calculateHeight = function () {
    var clone = this.cloneNode(true);
    clone.style.position = 'absolute';
    clone.style.visibility = 'hidden';
    clone.style.height = 'auto';
    clone.style.width = this.offsetWidth + 'px';
    this.parentElement.appendChild(clone);
    var height = clone.offsetHeight;
    this.parentElement.removeChild(clone);
    return height;
};

var elementsDisplayStyle = [];
HTMLElement.prototype.Visible = function (visible) {
    if (this.style.display != 'none') {
        elementsDisplayStyle[this] = this.style.display;
    }
    if (!(this in elementsDisplayStyle)) {
        elementsDisplayStyle[this] = 'block';
    }
    this.style.display = visible ? elementsDisplayStyle[this] : 'none';
}
