Number.prototype.round = function (digits) {
    digits = digits || 0;
    return parseFloat(this.toFixed(digits));
};

String.prototype.truncate = function (n) {
    return this.substr(0, n - 1) + (this.length > n ? '&hellip;' : '');
};

var Tools = { ver: "1.0" };

Tools.SendRequest = function (requestName, onSuccess, params, format) {
    var r = {
        request: requestName,
        onsuccess: onSuccess,
        params: params,
        format: format
    };

    var href = "query://" + JSON.stringify(r);
    if (!Page.get().isTemplate())
        window.open(href, "_self");

    Page.get().log(href);
}

Tools.Request = function (name) {

    // default update is empty
    this.updateView = function (viewData) {
    };

    this.requestName = name;
    this.start = new Date().getTime();
    this.end = new Date().getTime();
};

Tools.Request.prototype = {
    constructor: Tools.Request,

    getObjectName: function () {
        for (name in window) if (window[name] == this) return name;
        return "";
    },

    send: function (updateView, params, format) {
        if (updateView !== undefined)
            this.updateView = updateView;
        start = new Date().getTime();
        Tools.SendRequest(this.requestName, this.getObjectName() + ".onDataReceived", params, format);

        // send fake request with ViewData if it is a template
        if (Page.get().isTemplate())
            this.onDataReceived(ViewData);
    },

    onDataReceived: function (viewData) {
        end = new Date().getTime();
        this.updateView(viewData);
        if (start != 0)
            Page.get().logExecution(this.getExecutionTime());
        start = 0;
    },

    getExecutionTime: function () {
        return (end - start) / 1000.0;
    }
};

// list of different requests
var LoopRequest = new Tools.Request("get_loop");
var MAQAORequest = new Tools.Request("get_maqao");
var ArrayRequest = new Tools.Request("get_array");
var RowUpdateCallback = new Tools.Request("set_callback");
